c noisecalc.f -- Program to calculate def and aim for the script generator
c
c***************************************************************************
c                                                                          *
c                         Rowland NMR Toolkit                              *
c                  Jeffrey C. Hoch and Alan S. Stern                       *
c                                                                          *
c		         Copyright (c) 1993 by                             *
c               The Rowland Institute for Science, Inc.                    *
c                     100 Edwin H. Land Boulevard                          *
c                         Cambridge, MA 02142                              *
c		          All Rights Reserved			           *
c                                                                          *
c***************************************************************************
c
c
c	noisecalc fidflag ni3 ni2 ni1 n2 n1 filename dim
c	NOTE: Filename must contain a .
c Descriptions of other arguments ...
c
	program noisecalc
	implicit none
	include '../data.cmn'
	include '../access.cmn'
	include '../parse.cmn'
	include '../funcs.cmn'
	character*80 command_line
	integer length, tdim
	external main_routine
	call map
	call check_parameters
	call parse(0, command_line, length)

c Determine if data is 2D
	tdim = intg(6)
C        write(*,*) tdim
	if (nptype(ldim(tdim)).ne.2) then
		write(*,*) 'Data is not complex'
		return
	endif
        if (dom(ldim(tdim)).ne.'F') then
		write(*,*) 'Data is not in frequency domain'
		call exit
	endif
                if (npts(ldim(tdim)).gt.4096) then
		write(*,*) 'Ni too big, must be less then 4096'
		return
	endif
c Carry out the function
C	write(*,*) npts(ldim(tdim))
        call to_main(main_routine, cbufptr)
	end

c Parse the command-line arguments
	subroutine main_routine(cbuf)
	implicit none
	real cbuf(*)
	include '../data.cmn'
	include '../access.cmn'
	include '../parse.cmn'
	include '../funcs.cmn'
        
        real sumnoise, noiseav, powsp(5000), a
        integer ptr, n, istr, i, j, imoff, peak (5000), samp, hpt, z
        real stdev, variance, sumvar, maxamp, toptw, toppeak
        real percent, amp, aim1, aim2, aim3, def1, def2, def3
        logical findamp, average, noise
        integer iunit, ni1, ni2, ni3, n1, n2, hghpnt(5000), rng, hlf
        integer tdim, toppeaki, hghpnt1(5000), k
        real hghamp(5000), hghamp1(5000)
        
c Interpret the arguments and perform the function
        if (flt(1).ge.100.0.or.flt(1).lt.0.0) then
         write(*,*) 'Value must be between 0.0-99.0'
         return
        endif
        tdim = intg(6)
        if (kfl .eq. 0) then
            iunit = 6
        else
            iunit = 10
            open(unit=iunit, file=fnam(1:kfl), err=200)
        endif
        noise = .false.
        findamp = .false. 
        average = .false.
        if (word(1)(1:3) .eq. 'NOI' ) noise	= .true.
        n = npts(ldim(tdim))
        istr = istrides(ldim(tdim))
        ptr = 1
        sumnoise = 0.
        noiseav = 0.
        toptw  = 0.
        imoff = imag_offsets(ldim(tdim))
        if (noise.eqv..true.) then
        percent = 0.
        else
        percent = flt(1)
        endif
        sumnoise = 0.
        noiseav = 0.
        maxamp = 0.
        samp = 0
        sumvar = 0.
        z = 15
C        write(*,*) 'test', ptr, istr, n
C	Estimates peak regions        
10	continue        
        hpt = 1
        z = z + 5
        toppeak = 0.
        do i = 1, n
            amp = ((cbuf(ptr))**2+(cbuf(ptr+imoff))**2)**0.5
            powsp(i) = amp
            if(findamp.eqv..true.) then	
                peak(i) = 0
                if(amp.gt.maxamp) peak(i) = 1	
                 if(amp.gt.toptw) then
                  hlf = nint(float(n)*0.5)
                  rng = nint(float(n)*0.1)
                  if(i.gt.hlf+rng.or.i.lt.hlf-rng) then
                   hghpnt(hpt) = i
                   hghamp1(hpt) = amp
                   hghamp(hpt) = amp
                   hpt = hpt+1
                   if (amp.gt.toppeak) then 
                    toppeak = amp
                    toppeaki = i
                   endif
                  endif
                 endif
            endif
            ptr = ptr+istr
        enddo
                

        if (hpt.lt.10.and.findamp.eqv..true.) goto 70
        if (findamp.eqv..true.) goto 20
        call SORT(powsp, n)         
        a = float(n)*percent*0.01
        j = nint(a)
        maxamp = powsp(n-j)
70	Continue
        toptw = powsp(n-z)
        findamp = .true.
        ptr = 1
        goto 10         
20	continue
C	Calculates statistics

        ptr = 1
        do i = 1, n
            if(peak(i).ne.1) then
              if(average.eqv..true.) then
                sumvar = sumvar+(cbuf(ptr)-noiseav)**2
C                write(*,*) cbuf(ptr)
                else
                sumnoise = sumnoise+cbuf(ptr)
                samp = samp + 1
              endif
            endif
            ptr = ptr +istr
        enddo
        if (average.eqv..true.) goto 30
        noiseav = sumnoise/float(samp)
        average = .true.
        goto 20
30      continue


C        Sort 10 highest amplitudes

       call SORT(hghamp, hpt-1)
       k = 0
       do i = hpt-1, 1, -1
        k = 1 +k
        do j = hpt-1, 1, -1
         if (hghamp(i).eq.hghamp1(j)) then
          hghpnt1(k) = hghpnt(j)
C          write(*,*) hghpnt1(k), i
         endif
        enddo
       enddo
C	Calculate def and aim for all dimensions

        variance = sumvar/float(samp)
        stdev = variance**0.5  

        ni3 = intg(1)
        ni2 = intg(2)
        ni1 = intg(3)
        n2 = intg(4)
        n1 = intg(5)
C	Currrent dimension
        aim3 = (stdev*(float(n)**0.5))/(float(ni3)**0.5)
        def3 = stdev
C	Slow dimension
        aim2 = stdev
        def2 = (stdev*(float(ni2)**0.5))/(float(n2)**0.5)
C	Very slow dimension
        aim1 = def2
        def1 = (aim1*(float(ni1)**0.5))/(float(n1)**0.5)

C	Prints stuff to file
        if (noise.eqv..false.) then    
40	FORMAT('Estimated standard deviation =', F9.3)
        write(iunit, 40) stdev
        else
50	FORMAT('Standard deviation =', F9.3)
        write(iunit, 50) stdev 
        endif       
60	FORMAT('AIM for fast dimension =', F9.3)
61	FORMAT('DEF for fast dimension =', F9.3)
62	FORMAT('AIM for first indirect dimension =', F9.3)
63	FORMAT('DEF for first indirect dimension =', F9.3)
64	FORMAT('AIM for second indirect dimension =', F9.3)
65	FORMAT('DEF for second indirect dimension =', F9.3)
66	FORMAT('Highest peak amplitued points outside central region:', 10I6)
        write(iunit, 60) aim3
        write(iunit, 61) def3
        write(iunit, 62) aim2
        write(iunit, 63) def2
        write(iunit, 64) aim1
        write(iunit, 65) def1
        write(iunit, 66) (hghpnt1(i), i=1, 10)
        write(*,*) "Noise based Aim and Def calculation peformed."
        RETURN
200	write(*,*) 'Error opening output file ', fnam(1:kfl)
       END


      SUBROUTINE SORT (X, N)
C
C        ALGORITHM AS 304.8 APPL.STATIST. (1996), VOL.45, NO.3
C
C        Sorts the N values stored in array X in ascending order
C
      INTEGER N
      REAL X(N)
C
      INTEGER I, J, INCR
      REAL TEMP
C
      INCR = 1
C
C        Loop : calculate the increment
C
   10 INCR = 3 * INCR + 1
      IF (INCR .LE. N) GOTO 10

C
C        Loop : Shell-Metzner sort
C
   20 INCR = INCR / 3
      I = INCR + 1
   30 IF (I .GT. N) GOTO 60
      TEMP = X(I)
      J = I
   40 IF (X(J - INCR) .LT. TEMP) GOTO 50
      X(J) = X(J - INCR)
      J = J - INCR
      IF (J .GT. INCR) GOTO 40
   50 X(J) = TEMP
      I = I + 1
      GOTO 30
   60 IF (INCR .GT. 1) GOTO 20
C
      RETURN
      END